<?php
/**
 * @copyright  Copyright (c) 2018 Icredit 
 * @version 1.6.1
 * @author iCredit
*/

if (!defined('_PS_VERSION_'))
	exit;

class ICreditSuccessModuleFrontController extends ModuleFrontController
{
	public $ssl = true;
	public $display_column_left = false;

	public function initContent()
	{		
		parent::initContent();		
	}

	public function postProcess()
	{			

	/*$order = new Order(14);	
		echo '<pre>';
		print_r($order);
		die;*/
		/*echo Configuration::get('RedirectURL');
		die;
	*/	
		
		$js = _PS_BASE_URL_.'/modules/iCredit/js/jquery.cookie.js';
		$status = Configuration::get('Status');
		$window_type = Configuration::get('WindowType');		
		if(Configuration::get('RedirectURL') == '')
        {
        	//$redirect_url = _PS_BASE_URL_.__PS_BASE_URI__.'module/iCredit/success';
        	$redirect_url = $this->context->link->getModuleLink('iCredit','success', array());
        }
        else
        {
        	$redirect_url = Configuration::get('RedirectURL');
        }
		$price = Configuration::get('amount');
		$id_order = Configuration::get('id_order');

		$this->context->smarty->assign(
			array(
				'status' => $status,
				'id_order' => $id_order,
				'price' => Tools::displayPrice($price, $this->context->currency->id),
				'window_type' => $window_type,
				'redirect' => $redirect_url,
				'cookiejs'  => $js,
				'HOOK_ORDER_CONFIRMATION' => $this->displayOrderConfirmation($id_order),
				'HOOK_PAYMENT_RETURN' => $this->displayPaymentReturn($id_order,$status)
			)
		);
		
		$this->setTemplate('order-confirmation.tpl');
	}



	private function displayHook($id,$status=NULL)
	{				
		/*$sql = "SELECT * from "._DB_PREFIX_."module where name = 'iCredit'";						
		Db::getInstance()->execute($sql);*/
		
		

		$id_order = $id;
		$order = new Order((int)$id_order);
		$currency = new Currency((int)$order->id_currency);

		if (Validate::isLoadedObject($order))
		{
			$params['objOrder'] = $order;
			$params['currencyObj'] = $currency;
			$params['currency'] = $currency->sign;
			$params['total_to_pay'] = $order->getOrdersTotalPaid();
			$params['status'] = $status;

			return $params;
		}		
	}

	/**
	 * Execute the hook displayPaymentReturn
	 */
	public function displayPaymentReturn($id_order,$status)
	{
		$id = $id_order;
		$sql = "SELECT * FROM `ps_module` WHERE `name`= 'iCredit'";
		$results = Db::getInstance()->ExecuteS($sql);
		$id_module = $results[0]['id_module'];

		$params = $this->displayHook($id,$status);

		if ($params && is_array($params))
			return Hook::exec('displayPaymentReturn', $params, (int)$id_module);
		return false;
	}

	/**
	 * Execute the hook displayOrderConfirmation
	 */
	public function displayOrderConfirmation($id_order)
	{
		$id = $id_order;
		$params = $this->displayHook($id);

		if ($params && is_array($params))
			return Hook::exec('displayOrderConfirmation', $params);
		return false;
	}

}
